#define WEEK 604800
#define DAY 86400

int daysInMonth[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};// 29 для февраля в високостный год
int reset_times[3];

Handle g_hGFwd_OnReset;

public Plugin myinfo =
{
	name = "DWM Reset",
	author = "VOLK_RuS",
	description = "Reset on every day/week/month",
	version = "1.0",
	url = "awpcountry.ru (Discord: VOLK_RuS#5031)"
};

public APLRes AskPluginLoad2(Handle hMyself, bool bLate, char[] sError, int iErr_max) 
{
	CreateNative("dwm_GetTime", Native_GetTime);
	g_hGFwd_OnReset = CreateGlobalForward("dwmOnReset", ET_Ignore, Param_Cell, Param_Cell);

	RegPluginLibrary("dwm_reset");

	return APLRes_Success;
}

public int Native_GetTime(Handle hPlugin, int iNumParams)
{
	char TimeReturn[64];
	
	int iType = GetNativeCell(1);
	int iMode = GetNativeCell(2);
	int iConvert = GetNativeCell(3);
	GetNativeString(4, TimeReturn, sizeof(TimeReturn));
	
	int SecondsOrUnix = GetResetTime(iType, iMode, iConvert, TimeReturn);
	
	if(iConvert)
	SetNativeString(4, TimeReturn, sizeof(TimeReturn));
	
	return SecondsOrUnix;
}

public GetResetTime(iType, iMode, iConvert, char TimeReturn[64])
{
	int rValue;
	char format[64];
	
	switch(iType)
	{
		case 0: //daily
		{
			if(iMode) //Время до сброса 10ч 1м
			{
				rValue = reset_times[0] - GetTime();
				
				if(iConvert)
				{
					Format(format, sizeof(format), "%iч %iм", 
					rValue / 3600, rValue / 60 % 60);
				}
			}
			else	//Время сброса дд.мм.гг
			{
				rValue = reset_times[0];
				
				if(iConvert)
				{
					FormatTime(format, sizeof(format), "%d.%m %H:%M:%S", rValue);
				}
			}
		}
		case 1: //weekly
		{
			if(iMode) //Время до сброса 10ч 1м
			{
				rValue = reset_times[1] - GetTime();
				
				if(iConvert)
				{
					Format(format, sizeof(format), "%iд %iч %iм", rValue / DAY, rValue / 3600 % 24, rValue / 60 % 60);
				}
			}
			else	//Время сброса дд.мм.гг
			{
				rValue = reset_times[1];
				
				if(iConvert)
				{
					FormatTime(format, sizeof(format), "%d.%m %H:%M:%S", rValue);
				}
			}
		}
		case 2: //monthly
		{
			if(iMode) //Время до сброса 10ч 1м
			{
				rValue = reset_times[2] - GetTime();
				
				if(iConvert)
				{
					Format(format, sizeof(format), "%iд %iч", 
					rValue / DAY, rValue / 3600 % 24);
				}
			}
			else	//Время сброса дд.мм.гг
			{
				rValue = reset_times[2];
				
				if(iConvert)
				{
					FormatTime(format, sizeof(format), "%d.%m %H:%M:%S", rValue);
				}
			}
		}
	}
	
	strcopy(TimeReturn, sizeof(TimeReturn), format);
	return rValue;
}

public OnMapStart()
{
	RegAdminCmd("sm_dwm_forcereset", ForceReset, ADMFLAG_ROOT, "Force reset for a day/week/month.");
	RegAdminCmd("sm_dwm_reload", Reload, ADMFLAG_ROOT, "Reload dwm_reset.cfg file");
	ReadCfgFile();
	CreateTimer(30.0, timer_check_reset, _, TIMER_FLAG_NO_MAPCHANGE|TIMER_REPEAT);
}



public Action Reload(client, args)
{
	ReadCfgFile();
	return Plugin_Handled;
}

public Action ForceReset(client, args)
{
	char arg1[8];
	
	if(args < 1)
	{
		if(client > 0)	
		PrintToChat(client, "[DWM Reset] Usage: sm_dwm_forcereset <d/w/m>");
		
		return Plugin_Handled;
	}
	
	GetCmdArg(1, arg1, 8);
	
	switch(arg1[0])
	{
		case 'd':
		{
			ResetDaily(true);
		}
		case 'w':
		{
			ResetWeekly(true);
		}
		case 'm':
		{
			ResetMonthly(true);
		}
	}
	
	return Plugin_Handled;
}

public ReadCfgFile()
{
	char path[PLATFORM_MAX_PATH];

	Handle kv = CreateKeyValues("resets"); 
	BuildPath(Path_SM, path, sizeof(path), "configs/dwm_reset.txt");
	if (FileToKeyValues(kv, path)) 
	{			
		reset_times[0] = KvGetNum(kv, "next_daily_reset", GetTime() + DAY);
		reset_times[1] = KvGetNum(kv, "next_weekly_reset", GetTime() + WEEK);
		reset_times[2] = KvGetNum(kv, "next_monthly_reset", GetTime() + DAY);
		
		/*char dtime[20], wtime[20], mtime[20];
		FormatTime(dtime, 20, "%d.%m %H:%M:%S", reset_times[0]);
		FormatTime(wtime, 20, "%d.%m %H:%M:%S", reset_times[1]);
		FormatTime(mtime, 20, "%d.%m %H:%M:%S", reset_times[2]);
		
		PrintToServer("Next daily reset in %ih:%im (%s), weekly in %id:%ih:%im (%s), monthly in %id:%ih (%s)", 
		(reset_times[0] - GetTime()) / 3600, (reset_times[0] - GetTime()) / 60 % 60, dtime, 
		(reset_times[1] - GetTime()) / DAY, (reset_times[1] - GetTime()) / 3600 % 24, (reset_times[1] - GetTime()) / 60 % 60, wtime,
		(reset_times[2] - GetTime()) / DAY, (reset_times[2] - GetTime()) / 3600 % 24, mtime);*/
	}
	delete kv;
}

public Action timer_check_reset(Handle timer)
{
	CheckReset();
}

public CheckReset()
{
	if(reset_times[0] - GetTime() <= 0)//daily
	{
		ResetDaily();
	}
	if(reset_times[1] - GetTime() <= 0)//weekly
	{
		ResetWeekly();
	}
	if(reset_times[2] - GetTime() <= 0)//monthly
	{
		ResetMonthly();
	}
}

ResetDaily(bool force = false)
{	
	int new_time = reset_times[0];
	do
	{
		new_time += DAY;
	}
	while(new_time < GetTime())
	
	ChangeTimeInCfg("next_daily_reset", new_time);
	
	Call_StartForward(g_hGFwd_OnReset);
	Call_PushCell(0);
	Call_PushCell(force);
	Call_Finish();
}

ResetWeekly(bool force = false)
{
	int new_time = reset_times[1];
	do
	{
		new_time += WEEK;
	}
	while(new_time < GetTime())
	
	ChangeTimeInCfg("next_weekly_reset", new_time);
	
	Call_StartForward(g_hGFwd_OnReset);
	Call_PushCell(1);
	Call_PushCell(force);
	Call_Finish();
}

ResetMonthly(bool force = false)
{
	bool vis = false;
	char resetmonth[16], resetyear[16];
	FormatTime(resetyear, sizeof(resetyear), "%Y", GetTime()); // Год сброса ХХХХ
	FormatTime(resetmonth, sizeof(resetmonth), "%m", reset_times[2]); // Месяц сброса в формате 01-12
	int iResetYear = StringToInt(resetyear);
	int iResetMonth = StringToInt(resetmonth);
	
	int iNewResetTime = reset_times[2];
	
	do
	{
		vis = false;
		
		if(((iResetYear%4) == 0) && (((iResetYear%100)!=0) || ((iResetYear%400) == 0)))// Определение високосного года
		{
			vis = true;
		}
	
		iNewResetTime += (daysInMonth[iResetMonth-1] + (iResetMonth + 1 == 2 && vis ? 1:0)) * DAY;// Колво секунд
		
		if(iResetMonth < 12)
		{
			iResetMonth++;
		}
		else
		{
			iResetYear++;
			iResetMonth = 1;
		}
	}
	while(iNewResetTime < GetTime())
	
	ChangeTimeInCfg("next_monthly_reset", iNewResetTime);
	
	Call_StartForward(g_hGFwd_OnReset);
	Call_PushCell(2);
	Call_PushCell(force);
	Call_Finish();
}

public ChangeTimeInCfg(char[] type, int next_time)
{
	char path[PLATFORM_MAX_PATH];

	Handle kv = CreateKeyValues("resets");
	BuildPath(Path_SM, path, sizeof(path), "configs/dwm_reset.txt");
	if (FileToKeyValues(kv, path))
	{			
		KvSetNum(kv, type, next_time);
		
		KeyValuesToFile(kv, path);
	}
	delete kv;
	
	ReadCfgFile();
}